#include <SDL2/SDL.h>
#include "hero.h"
#include "scene.h"

#define TIME 50

int main() {
	SDL_Window *window;
	SDL_Event event;
	SDL_Renderer *renderer;
	int quit=0;
	
	

	if (SDL_VideoInit(NULL) < 0) {
		SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't initialize SDL video: %s\n",
                SDL_GetError());
        exit(1);
	}
	
	window = SDL_CreateWindow("Fenetre",
			0, 0,
	    720, 520, SDL_WINDOW_SHOWN);
	
	renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);

	/* On cree la scene */
	printf("Creation de la scene\n");
	Scene *scene = new_scene();
	printf("Chargement de la scene : map\n");
	Scene_load_scene(scene, "map.txt", "image_tuile40x40.bmp");
	
	/* On cree notre personnage */
	Hero *hero = new_hero();
	hero->pos.x = 80;
	hero->pos.y = 120;
	
	/* On affiche la carte et le personnage */
	display_map_sdl(scene->map, renderer);
	display_hero_sdl(hero, renderer, 0, 0, W, POS0);

	SDL_RenderPresent(renderer);
			
	while ( !quit ) {
		if ( SDL_PollEvent(&event) ) {
			switch (event.type) {
				case SDL_QUIT:
					quit=1;
					break;
				case SDL_KEYDOWN:
					switch (event.key.keysym.sym) {
						case SDLK_LEFT:
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, -SIZE_BMP_HERO/4, 0, E, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, -SIZE_BMP_HERO/4, 0, E, POS0);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, -SIZE_BMP_HERO/4, 0, E, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, -SIZE_BMP_HERO/4, 0, E, POS0);
							break;
						case SDLK_RIGHT:
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, SIZE_BMP_HERO/4, 0, W, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, SIZE_BMP_HERO/4, 0, W, POS0);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, SIZE_BMP_HERO/4, 0, W, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, SIZE_BMP_HERO/4, 0, W, POS0);
							break;
						case SDLK_DOWN:
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, SIZE_BMP_HERO/4, S, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, SIZE_BMP_HERO/4, S, POS0);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, SIZE_BMP_HERO/4, S, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, SIZE_BMP_HERO/4, S, POS0);
							break;
						case SDLK_UP:
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, -SIZE_BMP_HERO/4, N, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, -SIZE_BMP_HERO/4, N, POS0);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, -SIZE_BMP_HERO/4, N, POS1);
							SDL_Delay(TIME);
							display_map_sdl(scene->map, renderer);
							display_hero_sdl(hero, renderer, 0, -SIZE_BMP_HERO/4, N, POS0);
							break;
					}//end switch event.key.keysym.sym
					break;
			}//end switch event.type
		}//end if PollEvent
	}//end while quit
	
	SDL_DestroyWindow(window);
	SDL_Quit();
	return 0;
}
